/************************************************************
 * error.c --- Swan systems errors			    *
 * Jun Yang, November 17, 1994				    *
 ************************************************************/

/*--------------- Header Files ---------------*/

#include "swan.h"

/*--------------- Variables ---------------*/

char	_errorstr[256] ;

struct _error_message _sw_error_list[] = {
{SWE_INTN, "Swan internal errors"},
{SWE_NOCONNECT, "Connection to Swan is refused"},
{SWE_NOMEMORY, "Not enough memory"},
{SWE_NOGRAPH, "Invalid graph ID"},
{SWE_NONODE, "Invalid node ID"},
{SWE_NOEDGE, "Invalid edge ID"},
{SWE_NOLC, "Invalid layout component ID"},
{SWE_NOATTR, "Invalid attribute specification"},
{SWE_BADGRAPHID, "Graph ID already used"},
{SWE_BADLCID, "Layout component ID already used"},
{SWE_NONBNODE, "No such neighbour node"},
{SWE_BADMENUITEM, "No such menu item"},
{SWE_INVRECT, "Incorrect rectangle type"},
{SWE_INVELLIPSE, "Incorrect ellipse type"},
{SWE_INVNODE, "Invalid node type"},
{SWE_REDEFNODE, "Node ID already used"},
{SWE_REDEFEDGE, "Edge ID already used"},
{SWE_MORENODES, "Too many vertices created"}
} ;
	
/*-------------- Functions ---------------*/

bool _sw_geterrormsg(int err_no, char* err_msg)
{
	register int 	i ;

	for (i = 0 ; 
	     i < sizeof(_sw_error_list)/sizeof(struct _error_message) ;
	     i++)  
	    if (err_no == _sw_error_list[i].index) {
		if (err_msg == NULL)
		    return FALSE ;
		strcpy(err_msg, _sw_error_list[i].message) ;
		return TRUE ;
	    }
	return FALSE ;
}

/************************************************************
 * End of error.c                 			    *
 ************************************************************/
