/************************************************************ 
 * layomp.c --- Member Functions of class BasicLayoutComp   *
 * Jun Yang, November 17, 1994				    *
 ************************************************************/

/*--------------- Header Files ---------------*/

#include <iostream.h>
#include <stdio.h>
#include <math.h>
#include "swan.h"
#include "laykk.h"

#define MIN_X_SEPARATION 10
#define STTOPDIST	10

/*--------------- Member functions of BasicLayoutComp ---------------*/

BasicLayoutComp::BasicLayoutComp(LC_ID lc_id, LAYOUTCOMPTYPE lc_type)
{
	register int	i ;

	eid = (lc_id == NULLLCID) ? (LC_ID)this : lc_id ;
	id = this ;
	type = lc_type ;
	pid = NULL ;
	pnode = NULL ;
	fnode = NULL ;
	bbox = EmptyBox ;
	rpos = UnsetPos ;
	ppos = UnsetPos ;
	ch_lclist = new LCLIST ;
	ch_nodelist = new NODELIST ;

	lc_info = new LCINFO ;
	lc_info->left_margin = MINLCMARGIN ;
	lc_info->right_margin = MINLCMARGIN ;
	lc_info->top_margin = MINLCMARGIN ;
	lc_info->bottom_margin = MINLCMARGIN ;
	lc_info->distX = MINDISTX ;
	lc_info->distY = MINDISTY ;
	node_info = new NODEINFO ;
	edge_info = new EDGEINFO ;
	node_type = _sw_cur_nodeType ;

	for (i = 0 ; i < MAXBUSLINE ; i++) {
	    rbus[i] = FALSE ;
	    bbus[i] = FALSE ;
	}
}

BasicLayoutComp::BasicLayoutComp(void)
{
	register int	i ;

	eid = (LC_ID)this ;
	id = this ;
	pid = NULL ;
	pnode = NULL ;
	fnode = NULL ;
	bbox = EmptyBox ;
	rpos = UnsetPos ;
	ppos = UnsetPos ;
	ch_lclist = new LCLIST ;
	ch_nodelist = new NODELIST ;
	lc_info = new LCINFO ;
	lc_info->left_margin = MINLCMARGIN ;
	lc_info->right_margin = MINLCMARGIN ;
	lc_info->top_margin = MINLCMARGIN ;
	lc_info->bottom_margin = MINLCMARGIN ;
	lc_info->distX = MINDISTX ;
	lc_info->distY = MINDISTY ;
	node_info = new NODEINFO ;
	edge_info = new EDGEINFO ;
	node_type = _sw_cur_nodeType ;

	for (i = 0 ; i < MAXBUSLINE ; i++) {
	    rbus[i] = FALSE ;
	    bbus[i] = FALSE ;
	}
}

BasicLayoutComp::~BasicLayoutComp(void)
{
	BasicNode*	temp_node ;
	BasicLayoutComp *temp_lc ;
	bool		ok ;

	delete ch_nodelist ;
	ch_nodelist = NULL ;
		
/*
	    ok = (*ch_lclist).getFirstNode(temp_lc) ;
	    while (ok) {
		delete temp_lc ;
	        ok = (*ch_lclist).getNextNode(temp_lc) ;
	    }
*/
	delete ch_lclist ;
	ch_lclist = NULL ;
		
	delete lc_info ;
	lc_info = NULL ;
	delete node_info ;
	node_info = NULL ;
	delete edge_info ;
	edge_info = NULL ;
	active = FALSE ;
}

bool BasicLayoutComp::setID(LAYOUTCOMPID lc_id)
{
	id = lc_id ;
        return TRUE ;
}

LC_ID BasicLayoutComp::getEID(void) 
{
	return eid ;
}

LAYOUTCOMPID BasicLayoutComp::getID(void)
{
	return id ;
}

bool BasicLayoutComp::setPID(LAYOUTCOMPID lc_id)
{
	pid = lc_id ;
        return TRUE ;
}

LAYOUTCOMPID BasicLayoutComp::getPID(void)
{
	return pid ;
}

bool BasicLayoutComp::setGID(BasicGraph* g_id)        
{
	gid = g_id ;
        return TRUE ;
}

BasicGraph* BasicLayoutComp::getGID(void)
{
	return gid ;
}

bool BasicLayoutComp::setRPos(LOCATION pos)
{
	rpos = pos ;
	return TRUE ;
}

LOCATION BasicLayoutComp::getRPos(void)
{
	return rpos ;
}

bool BasicLayoutComp::setPPos(LOCATION pos)
{
	ppos = pos ;
	return TRUE ;
}

LOCATION BasicLayoutComp::getPPos(void)
{
	return ppos ;
}

bool BasicLayoutComp::setBoxSize(BOXSIZE size)
{
	bbox = size ;
	return TRUE ;
}

BOXSIZE BasicLayoutComp::getBoxSize(void)
{
	return bbox ;
}

bool BasicLayoutComp::setType(LAYOUTCOMPTYPE lc_type)
{
	type = lc_type ;
	return TRUE ;
}

LAYOUTCOMPTYPE BasicLayoutComp::getType(void)
{
	return type ;
}

LCNBLIST* BasicLayoutComp::getChLCList(void)
{
	return ch_lclist ;
}

NODELIST* BasicLayoutComp::getChNodeList(void)
{
	return ch_nodelist ;
}

BasicNode* BasicLayoutComp::getFNode(void) 
{
	return fnode ;
}

void BasicLayoutComp::setFNode(BasicNode* temp_node) 
{
	fnode = temp_node ;
}

BasicNode* BasicLayoutComp::getPNode(void) 
{
	return pnode ;
}

void BasicLayoutComp::setPNode(BasicNode* temp_node) 
{
	pnode = temp_node ;
}

int BasicLayoutComp::getRBus(void)
{
        register int i;

        for (i = 1 ; i < MAXBUSLINE ; i++)
            if (rbus[i] == FALSE) {
                rbus[i] = TRUE ;
                return i ;
            }
        return -1 ;
}
 
int BasicLayoutComp::getBBus(void)
{
        register int i;

        for (i = 1 ; i < MAXBUSLINE ; i++)
            if (bbus[i] == FALSE) {
                bbus[i] = TRUE ;
                return i ;
            }
        return -1 ;
}

LAYOUTCOMPID BasicLayoutComp::searchNBLC(BasicNode* theNode)
{
	bool		ok ;
	LAYOUTCOMPID	temp_lc ;

	ok = (*ch_lclist).getFirstNode(temp_lc) ;
	while (ok) {
	    if (temp_lc->pnode == theNode)
		return temp_lc ;
	    ok = (*ch_lclist).getNextNode(temp_lc) ;
	}
	return NULL ;
}

// Input/Output 
//	. save			  
// 	. load			   

bool BasicLayoutComp::save(ofstream& lc_out, int level)
{
	BasicLayoutComp		*temp_lc ;
	BasicNode		*temp_node ;
	bool			ok ;

	if (lc_out == NULL)
	    return FALSE ;

	lc_out << '(' << level << ' ' << eid << ' ' << (*pid).getEID() 
	       << ' ' << type << ' ' << bbox.w << ' ' << bbox.h 
	       << ' ' << rpos.x << ' ' << rpos.y << ' ' ;

	if (pnode != NULL)
	    lc_out << (int)(*pnode).getID() << ' ' ;
	else 
	    lc_out << 0 << ' ' ;

	if (fnode != NULL)
	    lc_out << (int)(*fnode).getID() << ' ' ;
	else 
	    lc_out << 0 << ' ' ;

	lc_out << node_type << ' ' ;
	lc_out << lc_info->left_margin << ' ' 
	       << lc_info->right_margin << ' '
	       << lc_info->top_margin << ' '
	       << lc_info->bottom_margin << ' '
	       << lc_info->distX << ' ' << lc_info->distY << ' ' ;

	lc_out << (*ch_lclist).getNodeCount() << ' ' 
	       << (*ch_nodelist).getNodeCount() << ')' << '\n' ;
	
        lc_out << '(' << node_info->shape << ' ' << node_info->size.w <<
                ' ' << node_info->size.h << ' ' << 
                ' ' << node_info->color << ' ' << node_info->filled <<
                ' ' << node_info->lineTH << ')' << '\n' ;
        lc_out << '(' << edge_info->length << ' ' << edge_info->lineTH
               << ' ' << edge_info->color << ' ' <<
			edge_info->label_ppos.x
               << ' ' << edge_info->label_ppos.y << ')' << '\n' ;

	ok = (*ch_lclist).getFirstNode(temp_lc) ;
	while (ok) {
	    (*temp_lc).save(lc_out, level+1) ;
	    ok = (*ch_lclist).getNextNode(temp_lc) ;
	}

	ok = (*ch_nodelist).getFirstNode(temp_node) ;
	while (ok) {
	    (*temp_node).save(lc_out) ;
	    ok = (*ch_nodelist).getNextNode(temp_node) ;
	}
	return TRUE ;
}

bool BasicLayoutComp::load(ifstream& lc_in, int level, 
			      BasicLayoutComp* parent)
{
	char		c ;
	int		i, num_node, num_lc, temp_level ;
	LC_ID		temp_peid ;
	BasicLayoutComp	*temp_lc ;
	BasicNode	*temp_node ;
	NODELIST	*graph_nodelist ;
	bool		ok ;
	int		temp_pnode, temp_fnode ;

	if (lc_in == NULL)
	    return FALSE ;

	lc_in >> c ;
	if (c != '(')
	    return FALSE ;	
	lc_in >> temp_level ;
	if (temp_level != level)
	    return FALSE ;
	lc_in >> eid ;
	if (level == 0) {
	    pid = parent ;
	    lc_in >> temp_peid ;
	}
	else {
	    lc_in >> temp_peid ;
	    if (temp_peid != (*parent).getEID())
		return FALSE ;
	    pid = parent ;
	    gid = (*parent).getGID() ;
	}
	pnode_id = NULL ;
	fnode_id = NULL ;
	lc_in >> type >> bbox.w >> bbox.h
	      >> rpos.x >> rpos.y >> temp_pnode >> temp_fnode ;
	pnode_id = (NODEID)temp_pnode ;
	fnode_id = (NODEID)temp_fnode ;

	lc_in >> node_type ;
	lc_in >> lc_info->left_margin >> lc_info->right_margin 
	      >> lc_info->top_margin >> lc_info->bottom_margin 
	      >> lc_info->distX >> lc_info->distY 
	      >> num_lc >> num_node >> c ;
	if (c != ')') 
	    return FALSE ;
	
        // load node info
        lc_in >> c ;
        if (c != '(')
            return FALSE ;
        lc_in >> node_info->shape >> node_info->size.w >>
                 node_info->size.h >>
                 node_info->color >> node_info->filled >>
                 node_info->lineTH >> c ;
        if (c != ')')
            return FALSE ;

        // load edge info
        lc_in >> c ;
        if (c != '(')
            return FALSE ;
        lc_in >> edge_info->length >> edge_info->lineTH
              >> edge_info->color >> edge_info->label_ppos.x
              >> edge_info->label_ppos.y >> c ;
        if (c != ')')
            return FALSE ;

	// load children LCs
	for (i = 0 ; i < num_lc ; i++) {
	    temp_lc = new BasicLayoutComp ;
	    if (!(*temp_lc).load(lc_in, level+1, this))
		return FALSE ;
	    (*ch_lclist).insert(temp_lc) ;
	}
	
	// load nodes in this LC
	graph_nodelist = (*gid).getNodeList() ;
	for (i = 0 ; i < num_node ; i++) {
	    temp_node = new BasicNode ;
	    if (!(*temp_node).load(lc_in, this))
		return FALSE ;
	    temp_node->nblist = new NODENBLIST ;
	    (*ch_nodelist).insert(temp_node) ;
	    (*graph_nodelist).insert(temp_node) ;
	}
	
	return TRUE ;
}	

bool BasicLayoutComp::restorePFNode(void) 
{
	BasicLayoutComp	*temp_lc ;
	bool		ok ;

	if (pnode_id != NULL)
	    pnode = (*gid).searchNode(pnode_id) ;

	if (fnode_id != NULL)
	    fnode = (*gid).searchNode(fnode_id) ;

	ok = (*ch_lclist).getFirstNode(temp_lc) ;
	while (ok) {
	    (*temp_lc).restorePFNode() ;
	    ok = (*ch_lclist).getNextNode(temp_lc) ;
	}
	return TRUE ; 
}

// pick operation

bool BasicLayoutComp::inThisLC(int x, int y, PICKTYPE ptype)
{
	BasicLayoutComp*	temp_lc ;
	BasicNode*		temp_node ;
	bool			ok ;
	LOCATION		temp_pos ;
	BOXSIZE			temp_size ;

	if (ptype == PICKGRAPH) {
	    temp_pos.x = (int)(ppos.x * zoom_factor) -
                        sc_x_origin ;
	    temp_pos.y = (int)(ppos.y * zoom_factor) -
                        sc_y_origin ;
	    temp_size.w = (int)(bbox.w * zoom_factor) ;
	    temp_size.h = (int)(bbox.h * zoom_factor) ;
	    if (x < temp_pos.x || x > temp_pos.x + temp_size.w)
		return FALSE ;
	    if (y < temp_pos.y || y > temp_pos.y + temp_size.h)
		return FALSE ;
	    _sw_pick_graph = getGID() ;
	    return TRUE ;
	}

        // search it in children lc
        ok = (*ch_lclist).getFirstNode(temp_lc) ;
        while (ok) {
            if ((*temp_lc).inThisLC(x, y, ptype))
                return TRUE ;
            ok = (*ch_lclist).getNextNode(temp_lc) ;
        }
	
	// check in this layer according to pick type
	switch (ptype) {
	case PICKNODE :
            ok = (*ch_nodelist).getFirstNode(temp_node) ;
            while (ok) {
                if ((*temp_node).inThisNode(x, y))
                    return TRUE ;
                ok = (*ch_nodelist).getNextNode(temp_node) ;
            }
	    return FALSE ;
	
	default:
	    break ;
	}

	return FALSE ;
}

bool BasicLayoutComp::isDisplayed(void)
{
	return active ;
}

void BasicLayoutComp::enActive(void)
{
	active = TRUE ;
}

void BasicLayoutComp::disActive(void)
{
	active = FALSE ;
}

bool BasicLayoutComp::setChLCPPos(void)
{
	LAYOUTCOMPID	cur_lc, next_lc ;
	LOCATION	temp_pos ;
	bool		ok ;

	ok = (*ch_lclist).getFirstNode(cur_lc) ;
	if (!ok) 
	    return TRUE ;	// no child LC
	cur_lc->active = TRUE ;

	temp_pos = (*cur_lc).getRPos() ;
	if (temp_pos == UnsetPos) {
	    temp_pos.x = temp_pos.y = 0 ;
	    (*cur_lc).setRPos(temp_pos) ;
	}
	temp_pos.x += ppos.x ;
	temp_pos.y += ppos.y ;
	(*cur_lc).setPPos(temp_pos) ;
	(*cur_lc).setChLCPPos() ;
	ok = (*ch_lclist).getNextNode(next_lc) ;
	while (ok) {
	    temp_pos = (*next_lc).getRPos() ;
	    if (temp_pos == UnsetPos) {
		switch (type) {
		case LISTACROSS:
		case ARRAYACROSS:
		    next_lc->rpos.x = cur_lc->rpos.x + cur_lc->bbox.w ;
		    next_lc->rpos.y = cur_lc->rpos.y ;
		    break ;

		case LISTDOWN:
		case ARRAYDOWN:
		    next_lc->rpos.x = cur_lc->rpos.x ;
		    next_lc->rpos.y = cur_lc->rpos.y + cur_lc->bbox.h ;
		    break ;
		
		default:
		    return FALSE ;
		    break ;
		}
		temp_pos = (*next_lc).getRPos() ;
	    }
	    temp_pos.x += ppos.x ;
	    temp_pos.y += ppos.y ;
	    (*next_lc).setPPos(temp_pos) ;
	    (*next_lc).setChLCPPos() ;
	    cur_lc = next_lc ;
	    ok = (*ch_lclist).getNextNode(next_lc) ;
	}
	return TRUE ;
}
	
bool BasicLayoutComp::clearLC()
{
	// suspicious
        swg_clear(ppos, bbox) ;
        return TRUE ;
}

bool BasicLayoutComp::setNodeInfo(NODEINFO* n_info)
{
	*node_info = *n_info ;
	return TRUE ;
}

NODEINFO* BasicLayoutComp::getNodeInfo(void)
{
	return node_info ;
}

bool BasicLayoutComp::setEdgeInfo(EDGEINFO* e_info)
{
	*edge_info = *e_info ;
	return TRUE ;
}

EDGEINFO* BasicLayoutComp::getEdgeInfo(void)
{
	return edge_info ;
}

bool BasicLayoutComp::setNodeType(NODETYPE n_type)
{
        BasicNode*      temp_node ;
        bool         ok ;

	node_type = n_type ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            (*temp_node).setType(n_type) ;
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}

NODETYPE BasicLayoutComp::getNodeType(void)
{
	return node_type ;
}

bool BasicLayoutComp::setNodeColor(COLORTYPE n_color)
{
        BasicNode*      temp_node ;
        bool         ok ;

	node_info->color = n_color ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            (*temp_node).setColor(n_color) ;
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}

bool BasicLayoutComp::setNodeFilled(FLAG f_flag) 
{
        BasicNode*      temp_node ;
        bool         ok ;

	node_info->filled = f_flag ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            (*temp_node).setFilled(f_flag) ;
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}

bool BasicLayoutComp::setNodeWidth(int width) 
{
        BasicNode*      temp_node ;
        bool         ok ;

	node_info->size.w = width ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            (*temp_node).setWidth(width) ;
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}

bool BasicLayoutComp::setNodeHeight(int height) 
{
        BasicNode*      temp_node ;
        bool         ok ;

	node_info->size.h = height ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            (*temp_node).setHeight(height) ;
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}

bool BasicLayoutComp::setNodeLineTH(int line_TH) 
{
        BasicNode*      temp_node ;
        bool         ok ;

	node_info->lineTH = line_TH ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            (*temp_node).setLineTH(line_TH) ;
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}

bool BasicLayoutComp::setEdgeLength(int e_length) 
{
        BasicNode*      temp_node ;
        struct _nb_node* temp_nb ; 
        bool         ok, ok2 ;

	edge_info->length = e_length ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            ok2 = (*(temp_node->nblist)).getFirstNode(temp_nb) ;
            while (ok2) {
                (*(temp_nb->edge_ptr)).setLength(e_length) ;
                ok2 = (*(temp_node->nblist)).getNextNode(temp_nb) ;
            }
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}

bool BasicLayoutComp::setEdgeLineTH(int line_TH) 
{
        BasicNode*      temp_node ;
        struct _nb_node* temp_nb ; 
        bool         ok, ok2 ;

	edge_info->lineTH = line_TH ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            ok2 = (*(temp_node->nblist)).getFirstNode(temp_nb) ;
            while (ok2) {
                (*(temp_nb->edge_ptr)).setLineTH(line_TH) ;
                ok2 = (*(temp_node->nblist)).getNextNode(temp_nb) ;
            }
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}

bool BasicLayoutComp::setEdgeArrow(ARROWTYPE e_arrow) 
{
        BasicNode*      temp_node ;
        struct _nb_node* temp_nb ;
        bool         ok, ok2 ;

	edge_info->arrow_type = e_arrow ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            ok2 = (*(temp_node->nblist)).getFirstNode(temp_nb) ;
            while (ok2) {
                (*(temp_nb->edge_ptr)).setArrow(e_arrow) ;
                ok2 = (*(temp_node->nblist)).getNextNode(temp_nb) ;
            }
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}

bool BasicLayoutComp::setEdgeColor(COLORTYPE e_color) 
{
        BasicNode*      temp_node ;
        struct _nb_node* temp_nb ; 
        bool         ok, ok2 ;

	edge_info->color = e_color ;            
        ok = (*ch_nodelist).getFirstNode(temp_node) ;
        while (ok) {
            ok2 = (*(temp_node->nblist)).getFirstNode(temp_nb) ;
            while (ok2) {
                (*(temp_nb->edge_ptr)).setColor(e_color) ;
                ok2 = (*(temp_node->nblist)).getNextNode(temp_nb) ;
            }
            ok = (*ch_nodelist).getNextNode(temp_node) ;
        }
	return TRUE ;
}
	
/************************************************************
 * End of laycomp.c 					    *
 ************************************************************/
